#!/bin/bash
echo "c=========================== TACAS'23 Artifact ==============================|"
echo "c   Title: A GPU Tree Database for Explicit State Space Exploration          |"
echo "c   Created on:  23-12-2022                                                  |"
echo "c   Difficulty mode:  Hard (expected time: ~2+ days)                         |"
echo "c   Soft Prerequisites:  cuda-11.x screen openmpi python3.8 textx jinja2     |"
echo "c                        matplotlib numpy                                    |"
echo "c   Hard Prerequisites:  CUDA-enabled GPU machine with minimum:              |"
echo "c                        7 or higher compute capability                      |"
echo "c                        32 GB system memory                                 |"
echo "c                        24 GB device memory                                 |"
echo "c                        Graphics driver v470 or later                       |"
echo "c                        Ubuntu 20 or later                                  |"
echo "c============================================================================|"
if [[ -f "engine" ]]; then
	bash engine -mode hard -runs 5
else
	echo "fatal error: artifact cannot run without its engine."
fi
echo "c============================ END of Artifact ===============================|"