#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <omp.h>
#include <curand.h>
#include <curand_kernel.h>
#include "gpu_code.h"
#include "mt19937ar.h"

#define  LAMP_X_MASK            1008806316530991104L  // 0000 1110 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000
#define  LAMP_Y_MASK            8070450532247928832L  // 0111 0000 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000 | 0000 0000


/*unsigned int long long set_stVector (unsigned long long int stVector, int iproc, int jslot, int value)
{
     
                     //   int    q_mask      =    7; 0000 000 111
                     //   int turn_mask      =   56;       //0000 111 000
                     //   int   pc_mask      =  960;       //1111 000 000 program counter
                        int   masks[3]     = {7,56,960};
     unsigned long long int   ls_mask      = 1023;       //1111 111 111
                        int   offsets[3]   = {0, 3, 6};  
                        int   shift        = 10 * iproc; 
                     
     //printf ("value1 = %d\n", value << (shift + offsets[jslot]));    

     //printf ("value2 = %lld\n", stVector^((value) << (shift + offsets[jslot]) ) );

     stVector ^= ((stVector^((value) << (shift + offsets[jslot]))) & (masks[jslot] << shift)); 
    
     //printf("%lld\n", stVector);                        
     return stVector;
}*/



unsigned long long int initLamportBitState (int numproc)
{
    unsigned long long int state = 0;
    
    state += LAMP_X_MASK; // set x to LAMP_X_MAX
    state += LAMP_Y_MASK;  // set y to LAMP_Y_MAX
    return state;

}



int main (int argc, char * argv [])
{

    const int num_streams=450;//249
    cudaStream_t streams[num_streams];
    int str=0;
for (str=0; str<num_streams; str++)
{
    cudaStreamCreateWithFlags(&streams[str], cudaStreamNonBlocking);
}


//    int numphilo=15; //number of philosophers
//    int numphilo=8; //for leader election
//    int numphilo=6; //for peterson
    int numphilo=6; //for anderson
//      int numphilo=7; //for lamport   (doesn't work)
//    int numphilo=8; //for gen32
//    unsigned long long int randval=0;//for leader election
    unsigned long long int num_nodes = 0; //for philosophers
    unsigned long long int initial= 0;//this is set by operating on the number of philosophers to achieve (1111...01010101)
    int reachable=0;
    int reachables[num_streams];
    uint8_t * hashtable;
    uint8_t * hashtables[num_streams];
    uint8_t * gpu_hashtable;
    uint8_t * gpu_hashtables[num_streams];
int sizeMax=2000000;
uint32_t * tableMax2;
unsigned long long int countMax=0;
unsigned long long int bigcopy=0;
uint32_t itMax=0;
int selMax=0;
    bool * gpu_reported;
    bool * gpu_reporteds[num_streams];
    unsigned long long int * rep_table;
    unsigned long long int * rep_tables[num_streams];
    unsigned long long int * gpu_rep_table;
    unsigned long long int * gpu_rep_tables[num_streams];
    int g=0;//counter for bits
    int p=0;//counter for output
    int rep=0;//iterator
    unsigned long mtseed=373587883;//just some random prime number
    unsigned long mtmod=373587883;
    int table_size=49100;
    int rep_size=449100;//+50,000 per bit
    FILE *output;
    unsigned long long int rnd[100];//this is dumb, but let's test it
    bool rnd_count[100];
    int r=0;//rnd iterator

    unsigned long long int mix_a=0;
    unsigned long long int mix_b=0;
    unsigned long long int mix_as[num_streams];
    unsigned long long int mix_bs[num_streams];

    int order [96];

    curandState     * devStates;
    curandGenerator_t gen;
    const char *msg;

    curandState     * devStatess[num_streams];
    curandGenerator_t gens[num_streams];
for (str=0; str<num_streams; str++)
{
    reachables[str]=0;
}


    cudaError_t err = cudaSuccess;
    cudaSetDevice(0);
    Queue * cpuCoresQueues   = createCoresQueues ();
    Queue * gpuCoresQueues   = createGPUCoresQueues ();
    unsigned long long int   * cpuQueuesSlots   = createQueuesSlots ();
    unsigned long long int   * gpuQueuesSlots   = createGPUQueuesSlots();

    Queue * cpuCoresQueuess[num_streams];
    Queue * gpuCoresQueuess[num_streams];
    unsigned long long int   * cpuQueuesSlotss[num_streams];
    unsigned long long int   * gpuQueuesSlotss[num_streams];
    init_genrand(mtseed);
    Functions * cpuFunctionSet = createFunctions();//needed to hold hashing constants
    Functions * gpuFunctionSet = createGPUFunctions();

    Functions * cpuFunctionSets[num_streams];
    Functions * gpuFunctionSets[num_streams];

for (str=0; str<num_streams; str++)
{
    cpuCoresQueuess[str]   = createCoresQueues();
    gpuCoresQueuess[str]   = createGPUCoresQueues();
    cpuQueuesSlotss[str]   = createQueuesSlots();
    gpuQueuesSlotss[str]   = createGPUQueuesSlots();
    mtmod=mtseed+str;//could pick a different modification strategy
    init_genrand(mtmod);
    cpuFunctionSets[str] = createFunctions();//needed to hold hashing constants
    gpuFunctionSets[str] = createGPUFunctions();
}


tableMax2 = (uint32_t *) malloc (1000 * sizeMax * sizeof (uint32_t));
memset(tableMax2, 0, sizeof(uint32_t)*sizeMax*1000);


//-----
// Setting ND order, 24 combinations
//-----
order[0]=0;
order[1]=1;
order[2]=2;
order[3]=3;

order[(1*4)+0]=0;
order[(1*4)+1]=1;
order[(1*4)+2]=3;
order[(1*4)+3]=2;

order[(2*4)+0]=0;
order[(2*4)+1]=2;
order[(2*4)+2]=1;
order[(2*4)+3]=3;

order[(3*4)+0]=0;
order[(3*4)+1]=2;
order[(3*4)+2]=3;
order[(3*4)+3]=1;

order[(4*4)+0]=0;
order[(4*4)+1]=3;
order[(4*4)+2]=2;
order[(4*4)+3]=1;

order[(5*4)+0]=0;
order[(5*4)+1]=3;
order[(5*4)+2]=1;
order[(5*4)+3]=2;

order[(6*4)+0]=1;
order[(6*4)+1]=0;
order[(6*4)+2]=2;
order[(6*4)+3]=3;

order[(7*4)+0]=1;
order[(7*4)+1]=0;
order[(7*4)+2]=3;
order[(7*4)+3]=2;

order[(8*4)+0]=1;
order[(8*4)+1]=2;
order[(8*4)+2]=0;
order[(8*4)+3]=3;

order[(9*4)+0]=1;
order[(9*4)+1]=2;
order[(9*4)+2]=3;
order[(9*4)+3]=0;

order[(10*4)+0]=1;
order[(10*4)+1]=3;
order[(10*4)+2]=2;
order[(10*4)+3]=0;

order[(11*4)+0]=1;
order[(11*4)+1]=3;
order[(11*4)+2]=0;
order[(11*4)+3]=2;

order[(12*4)+0]=2;
order[(12*4)+1]=1;
order[(12*4)+2]=0;
order[(12*4)+3]=3;

order[(13*4)+0]=2;
order[(13*4)+1]=1;
order[(13*4)+2]=3;
order[(13*4)+3]=0;

order[(14*4)+0]=2;
order[(14*4)+1]=0;
order[(14*4)+2]=1;
order[(14*4)+3]=3;

order[(15*4)+0]=2;
order[(15*4)+1]=0;
order[(15*4)+2]=3;
order[(15*4)+3]=1;

order[(16*4)+0]=2;
order[(16*4)+1]=3;
order[(16*4)+2]=1;
order[(16*4)+3]=0;

order[(17*4)+0]=2;
order[(17*4)+1]=3;
order[(17*4)+2]=0;
order[(17*4)+3]=1;

order[(18*4)+0]=3;
order[(18*4)+1]=0;
order[(18*4)+2]=1;
order[(18*4)+3]=2;

order[(19*4)+0]=3;
order[(19*4)+1]=0;
order[(19*4)+2]=2;
order[(19*4)+3]=1;

order[(20*4)+0]=3;
order[(20*4)+1]=1;
order[(20*4)+2]=0;
order[(20*4)+3]=2;

order[(21*4)+0]=3;
order[(21*4)+1]=1;
order[(21*4)+2]=2;
order[(21*4)+3]=0;

order[(22*4)+0]=3;
order[(22*4)+1]=2;
order[(22*4)+2]=1;
order[(22*4)+3]=0;

order[(23*4)+0]=3;
order[(23*4)+1]=2;
order[(23*4)+2]=0;
order[(23*4)+3]=1;

copy_Constant_CPU2GPU_2D(order);

//-----
//Not pretty, but this is how we have to set our random selections
//-----
rnd[0]=2724573682;
rnd[1]=1492216537;
rnd[2]=1132903362;
rnd[3]=3242996771;
rnd[4]=4275361144;
rnd[5]=4078033071;
rnd[6]=651086860;
rnd[7]=1240057350;
rnd[8]=2550607503;
rnd[9]=2269235132;

/*rnd[0]=768;
rnd[1]=1440;
rnd[2]=1080;
rnd[3]=262176;
rnd[4]=1052672;
rnd[5]=5242880;
rnd[6]=4444444;
rnd[7]=33554912;
rnd[8]=134217792;
rnd[9]=1234567890;*/

rnd[10]=1442100140;
rnd[11]=4006204051;
rnd[12]=1126484376;
rnd[13]=2156529078;
rnd[14]=4060407080;
rnd[15]=951507193;
rnd[16]=3130009906;
rnd[17]=1912423075;
rnd[18]=1724117802;
rnd[19]=2278866624;

rnd[20]=2256772788;
rnd[21]=177865216;
rnd[22]=1886131292;
rnd[23]=3784743381;
rnd[24]=3077770975;
rnd[25]=3960460535;
rnd[26]=2272212880;
rnd[27]=3099642104;
rnd[28]=4028196542;
rnd[29]=4276981009;

rnd[30]=3148573739;
rnd[31]=3139047893;
rnd[32]=3087141048;
rnd[33]=4121465502;
rnd[34]=3392086205;
rnd[35]=2239781229;
rnd[36]=1449886365;
rnd[37]=242469469;
rnd[38]=611149635;
rnd[39]=2945944980;

rnd[40]=2115457847;
rnd[41]=1545958569;
rnd[42]=2666702071;
rnd[43]=3576398588;
rnd[44]=951268287;
rnd[45]=907061744;
rnd[46]=1874498046;
rnd[47]=3960419408;
rnd[48]=1417492509;
rnd[49]=731456838;

rnd[50]=3450441481;
rnd[51]=376155839;
rnd[52]=1642734799;
rnd[53]=1486906590;
rnd[54]=22693836;
rnd[55]=382261787;
rnd[56]=2295770959;
rnd[57]=3190043895;
rnd[58]=1277341516;
rnd[59]=3926948725;

rnd[60]=2890544779;
rnd[61]=209589084;
rnd[62]=872053432;
rnd[63]=749410935;
rnd[64]=3756820866;
rnd[65]=4032809493;
rnd[66]=36191491;
rnd[67]=1195901925;
rnd[68]=89929818;
rnd[69]=3836501419;

rnd[70]=4250701303;
rnd[71]=2274507151;
rnd[72]=2334260137;
rnd[73]=873519419;
rnd[74]=2075275443;
rnd[75]=400221074;
rnd[76]=3837981428;
rnd[77]=2879127877;
rnd[78]=9614535;
rnd[79]=2070503392;

rnd[80]=1161888038;
rnd[81]=170155645;
rnd[82]=1547432817;
rnd[83]=3144672524;
rnd[84]=59148843;
rnd[85]=1943332635;
rnd[86]=334126155;
rnd[87]=4119439421;
rnd[88]=3304030197;
rnd[89]=206142579;

rnd[90]=1963299479;
rnd[91]=2172004172;
rnd[92]=1218289947;
rnd[93]=1376476510;
rnd[94]=1658628670;
rnd[95]=1032954288;
rnd[96]=1327745764;
rnd[97]=80222616;
rnd[98]=263530022;
rnd[99]=3977529182;

copy_Constant_CPU2GPU_Rep(rnd);



err = cudaGetLastError();
    msg= cudaGetErrorString(err);

    if (err != cudaSuccess)
    {
        printf("-1CUDA error: %s \n", msg);
        return -1;
    }

clock_t initialTime = clock();
srand(time(NULL));

//*****
// This section of code creates the local control flow graph, including the locally pertinent chopsticks.
// Essentially, if the local state and chopsticks allow for a change, this will map the change (used in a XOR map),
// else no change will occur.  This mapping might be difficult to read because it is done at the bit-level, but
// I mapped it all out by hand and tested it in code to verify the correctness.

//-----
// For Others
//-----

/*     int bCFG [16];


    for(int i=0; i<16; i++)
    {
	bCFG[i]=0;
    }
    bCFG[0]=9;
    bCFG[3]=7;
    bCFG[4]=9;
    bCFG[5]=7;
    bCFG[10]=9;
    bCFG[13]=7; */

//-----
// For Leader Election
//-----
/*
    int bCFG [2];

    bCFG[0]=1;
    bCFG[1]=0;
*/

//-----
// For Anderson Algorithm
//
// Completely a redundant artifact
//-----

    int bCFG[2];

    bCFG[0]=0;
    bCFG[1]=1;



    //send the CFG to constant memory
    copy_Constant_CPU2GPU(bCFG);

err = cudaGetLastError();
    msg= cudaGetErrorString(err);

    if (err != cudaSuccess)
    {
        printf("0CUDA error: %s \n", msg);
        return -1;
    }




//-----
//
// Determine Initial State
//
//-----


/*
//philosophers initial state
    //printf("Num philo %d\n", numphilo);
    num_nodes = (unsigned long long int) 1 << (3*numphilo);//the total number of nodes possible
    //printf("Num nodes %lld\n", num_nodes);

    for(int i=0; i<numphilo; i++)//used to make a subtractable mask to obtain the initial state
    {
	initial+= ((unsigned long long int) 1<<((2*i)+1));
    }
    initial= ((num_nodes-1)-initial);//subtracts (0000...10101010) from (1111...11111111) to obtain (1111...01010101)

    //printf("Initial state %lld\n", initial);
*/

//Gen32 initial state
//    initial=0;
    //printf("Initial state %lld\n", initial);

//Leader election initial state
/*    for (int i=0; i<numphilo; i++)
    {
	randval=rand()%255;
	//printf("rand result %lld\n", randval);
	initial+=(unsigned long long int)(randval<<(i*8));
	//printf("initial so far %lld\n", initial);
    }
    //printf("Initial state %lld\n", initial);
*/


//Peterson initial state
//    initial=0;
//    printf("Initial state %lld\n", initial);

//Anderson initial state
    initial=16;

//Lamport initial state
//initial=initLamportBitState(numphilo);
//initial=8358680909344145417;
//8358680909344145418, 8358680909344154634, 8358680909344669706

//printf("Initial state %lld\n", initial);




    setInitialState (cpuCoresQueues, cpuQueuesSlots, initial );//set initial node to n 1s followed by n 01s (in binary)
    copyQUEUES_CPU2GPU (gpuCoresQueues, cpuCoresQueues, gpuQueuesSlots, cpuQueuesSlots);
    CURAND_CALL(curandCreateGenerator(&gen, CURAND_RNG_PSEUDO_DEFAULT));//create PRNG
    CURAND_CALL(curandSetPseudoRandomGeneratorSeed(gen, 1234ULL));//set seed
    CUDA_CALL(cudaMalloc((void **)&devStates , N * sizeof(curandState)));//allocate space for PRNG on device
    cudaMemcpy (gpuFunctionSet, cpuFunctionSet, sizeof(Functions), cudaMemcpyHostToDevice);
    hashtable = (uint8_t *) malloc (table_size * sizeof(uint8_t));
    gpu_hashtable = create8bGPUVector(table_size);
    cudaMemset(gpu_hashtable,0,sizeof(uint8_t)*table_size);
    cudaMalloc ((void**)&gpu_reported, (100) * sizeof(bool));
    rep_table = (unsigned long long int *) malloc (rep_size * sizeof(unsigned long long int));
    gpu_rep_table = createLLGPUVector(rep_size);
    cudaMemset(gpu_rep_table,0,sizeof(unsigned long long int)*rep_size);
    mix_a = rand() & 0xff;
    mix_a |= (rand() & 0xff) << 8;
    mix_a |= (rand() & 0xff) << 16;
    mix_a |= (rand() & 0xff) << 24;
    mix_b = rand() & 0xff;
    mix_b |= (rand() & 0xff) << 8;
    mix_b |= (rand() & 0xff) << 16;
    mix_b |= (rand() & 0xff) << 24;

for (str=0; str<num_streams; str++)
{
    setInitialState (cpuCoresQueuess[str], cpuQueuesSlotss[str], initial );//set initial node to n 1s followed by n 01s (in binary)
    copyQUEUES_CPU2GPU (gpuCoresQueuess[str], cpuCoresQueuess[str], gpuQueuesSlotss[str], cpuQueuesSlotss[str]);
    CURAND_CALL(curandCreateGenerator(&gens[str], CURAND_RNG_PSEUDO_DEFAULT));
    CURAND_CALL(curandSetPseudoRandomGeneratorSeed(gens[str], 1234ULL));
    CUDA_CALL(cudaMalloc((void **)&devStatess[str] , N * sizeof(curandState)));
    cudaMemcpy (gpuFunctionSets[str], cpuFunctionSets[str], sizeof(Functions), cudaMemcpyHostToDevice);
    hashtables[str] = (uint8_t *) malloc (table_size * sizeof(uint8_t));
    gpu_hashtables[str] = create8bGPUVector(table_size);
    cudaMemset(gpu_hashtables[str],0,sizeof(uint8_t)*table_size);
    cudaMalloc ((void**)&gpu_reporteds[str], (100) * sizeof(bool));
    rep_tables[str] = (unsigned long long int *) malloc (rep_size * sizeof(unsigned long long int));
    gpu_rep_tables[str] = createLLGPUVector(rep_size);
    cudaMemset(gpu_rep_tables[str],0,sizeof(unsigned long long int)*rep_size);
    mix_as[str] = rand() & 0xff;
    mix_as[str] |= (rand() & 0xff) << 8;
    mix_as[str] |= (rand() & 0xff) << 16;
    mix_as[str] |= (rand() & 0xff) << 24;
    mix_bs[str] = rand() & 0xff;
    mix_bs[str] |= (rand() & 0xff) << 8;
    mix_bs[str] |= (rand() & 0xff) << 16;
    mix_bs[str] |= (rand() & 0xff) << 24;
}

err = cudaGetLastError();
    msg= cudaGetErrorString(err);

    if (err != cudaSuccess)
    {
        printf("10CUDA error: %s \n", msg);
        return -1;
    }



cudaDeviceSynchronize();

    clock_t start = clock();



//Not sure if this will work because of dimensional problems
    stateSpaceExplorationFPGA<<<1, 32>>> (gpuCoresQueues, gpuFunctionSet, gpuQueuesSlots, gpu_reported, numphilo, devStates, gpu_hashtable, table_size, gpu_rep_table, mix_a, mix_b);
	//stateSpaceExplorationND<<<1, 32>>> (gpuCoresQueues, gpuFunctionSet, gpuQueuesSlots, gpu_reported, numphilo, devStates, gpu_hashtable, table_size, gpu_rep_table, mix_a, mix_b);



for (str=0; str<num_streams; str++)
{
    stateSpaceExplorationFPGA<<<1, 32, 48, streams[str]>>> (gpuCoresQueuess[str], gpuFunctionSets[str], gpuQueuesSlotss[str], gpu_reporteds[str], numphilo,
                                                  devStatess[str],   gpu_hashtables[str], table_size, gpu_rep_tables[str], mix_as[str], mix_bs[str]);
}

//we need to add a synchronization before we stop the clock
cudaDeviceSynchronize();												  
double stop = (double) clock();
printf ( "Time including initialization (sec. %f)\n", ( stop - initialTime ) / CLOCKS_PER_SEC );    
printf ( "Time BFS GPU (sec. %f)\n", ( stop - start ) / CLOCKS_PER_SEC );

    err = cudaGetLastError();
    msg= cudaGetErrorString(err);

    if (err != cudaSuccess)
    {
        printf("13CUDA error: %s \n", msg);
        return -1;
    }

copy_8bvectors_GPU2CPU (gpu_hashtable, hashtable, table_size);
copy_llvectors_GPU2CPU (gpu_rep_table, rep_table, rep_size);


for (str=0; str<num_streams; str++)
{
    copy_8bvectors_GPU2CPU (gpu_hashtables[str], hashtables[str], table_size);
    copy_llvectors_GPU2CPU (gpu_rep_tables[str], rep_tables[str], rep_size);
}
//hash output

sizeMax=sizeMax*1000;

//figure out counting
for (p=0; p<table_size; p++)
{
    for (g=0;g<8;g++)
    {
            rep=p+(50000*g);

bigcopy=rep_table[rep];//rep
itMax=((bigcopy/32)%sizeMax);
if(itMax>=sizeMax||itMax<0)
{
	itMax=itMax%sizeMax;
}
selMax=(bigcopy%32);
tableMax2[itMax]|=1<<selMax;


            /*for(r=0;r<100;r++)
		{
			if(rep_table[rep]==rnd[r])
			{
				//rnd_count[r]=true;
				printf("[%d]: %llu \n", r, rep_table[rep]);
			}
		}*/
    }

    for(str=0;str<num_streams;str++)
    {
	for(g=0;g<8;g++)
	{
		rep=p+(50000*g);

bigcopy=rep_tables[str][rep];//rep
itMax=((bigcopy/32)%sizeMax);
if(itMax>=sizeMax||itMax<0)
{
	itMax=itMax%sizeMax;
}
selMax=(bigcopy%32);
tableMax2[itMax]|=1<<selMax;

            	/*for(r=0;r<100;r++)
		{
			if(rep_tables[str][rep]==rnd[r])
			{
				//rnd_count[r]=true;
				printf("[%d]: %llu \n", r, rep_tables[str][rep]);
			}
		}*/

	}
    }
}

/*for(r=0;r<100;r++)
{
	if(rnd_count[r])
	{
		printf("%d \n", r);
	}
}*/



countMax=0;
for(p=0; p<sizeMax; p++)
{
	countMax+=__builtin_popcount(tableMax2[p]);
	//if(tableMax2[p]>0){printf("Present: %d\n",p);}

}
printf("Reachable states = %llu\n",countMax);
//printf("Popcount of 7 = %d\n", __builtin_popcount(7));
//printf("Popcount of 8 = %d\n",__builtin_popcount(8));
//printf("Popcount of 4294967295 = %d\n",__builtin_popcount(4294967295));


if((output=freopen("OUT", "a", stdout))==NULL){
printf("Cannot open file.\n");
exit(1);
}

printf("Reachable states = %llu\n",countMax);

fclose(output);

freopen("/dev/tty","w",stdout);

/*for(str=0;str<num_streams;str++)
{
    printf("Number of reachable states (%d) = %d \n", str,reachables[str]);
}*/

free(tableMax2);

    free(hashtable);
    free(rep_table);
    cudaFree(gpu_rep_table);
    cudaFree(devStates);
    cudaFree(gpu_reported);
    cudaFree(gpu_hashtable);
    cudaFree(gpuFunctionSet);
for(str=0;str<num_streams;str++)
{
    free(hashtables[str]);
    free(rep_tables[str]);
    cudaFree(gpu_rep_tables[str]);
    cudaFree(devStatess[str]);
    cudaFree(gpu_reporteds[str]);
    cudaFree(gpu_hashtables[str]);
    cudaFree(gpuFunctionSets[str]);
    cudaStreamDestroy(streams[str]);
}
    cudaDeviceReset();
    
    return 0;
}
